int header[] =  {0x2e736e64, 0x0000001c, 0x10000000, 0x00000003, 0x0000ac44,
	0x00000001, 0x62617a00};

#include <math.h>
#include <stdio.h>
#define NPOINTS 512

float amps[] =   {0, 0, 0, 0, 0, 0, .1, .1, .2, 2, .2, .1, .1};
float phases[] = {0, 0, 0, 0, 0, 0, .5, .8, .4, .0, .3, .2, .5};
int nsins = sizeof(amps)/sizeof(float);

main()
{
	short sbuf[NPOINTS];
	float fbuf[NPOINTS], max, conv;
	int i;
	for (i = 0; i < NPOINTS; i ++)
	{
		float sum = 0;
		int j;
		for (j = 0; j < nsins; j++)
			sum += amps[j] *
				cos((float)((i * (j+1) + NPOINTS * phases[j])
					 * (2. * 3.14159 / NPOINTS)));
		fbuf[i] = sum;
	}
	max = 0;
	for (i = 0; i < NPOINTS; i ++)
	{
		if (fbuf[i] > max) max = fbuf[i];
		else if (-fbuf[i] > max) max = -fbuf[i];
	}
	if (max == 0) conv = 1;
	else conv = 32767./max;
	for (i = 0; i < NPOINTS; i ++) sbuf[i] = fbuf[i] * conv;
	if (write(1, header, sizeof(header)) < sizeof(header) ||
		write(1, sbuf, sizeof(sbuf)) < sizeof(sbuf))
	{
		perror("write");
		exit(1);
	}
	exit(0);
}